<?php

namespace Drupal\commerce_signifyd\Signifyd;

use Drupal\commerce_signifyd\Entity\SignifydCaseInterface;

/**
 * {@inheritdoc}
 */
class Guarantees extends SignifydAbstract implements GuaranteesInterface {

  /**
   * {@inheritdoc}
   */
  public function submit(SignifydCaseInterface $case): array {
    try {
      $response = $this->signifydClient->sendGuarantee($case);

      if ($this->logging) {
        $this->logger->notice(t('<b>Response:</b> <pre><code>@response</code></pre>', [
          '@response' => print_r($response, TRUE),
        ]));
      }
      return $response;
    }
    catch (\Exception $e) {
      watchdog_exception('commerce_signifyd', $e);
    }
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function cancel(SignifydCaseInterface $case): array {
    try {
      $response = $this->signifydClient->cancelGuarantee($case);

      if ($this->logging) {
        $this->logger->notice(t('<b>Response:</b> <pre><code>@response</code></pre>', [
          '@response' => print_r($response, TRUE),
        ]));
      }

      return $response;
    }
    catch (\Exception $e) {
      watchdog_exception('commerce_signifyd', $e);
    }
    return [];
  }

}
